#include "myiic.h"
#include "delay.h"

u8 ack;

//ʼIIC
void IIC_Init(void)
{					     
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(	RCC_APB2Periph_GPIOB, ENABLE );	//ʹGPIOBʱ
	   
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6|GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP ;   //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_SetBits(GPIOB,GPIO_Pin_6|GPIO_Pin_7); 	//PB6,PB7 
}
//IICʼź
void Start_I2c(void)
{
	SDA_OUT();     //sda
	IIC_SDA=1;	
delay_us(12);	
	IIC_SCL=1;
delay_us(12);
 	IIC_SDA=0;//START:when CLK is high,DATA change form high to low 
delay_us(12);
	IIC_SCL=0;//ǯסI2Cߣ׼ͻ 
delay_us(12);
}	  
//IICֹͣź
void Stop_I2c(void)
{
	SDA_OUT();//sda
	IIC_SCL=0;
	IIC_SDA=0;//STOP:when CLK is high DATA change form low to high
delay_us(12);
	IIC_SCL=1; 
delay_us(12);
	IIC_SDA=1;//I2C߽ź
delay_us(120);	
}
/*******************************************************************
                 ֽݴͺ               
ԭ: void  SendByte(uchar c);
:  cͳȥ,ǵַ,Ҳ,ȴӦ,
     ״̬λв.(ӦӦʹack=0 )     
     ack=1; ack=0ʾӦ𻵡
********************************************************************/
void  SendByte(u8 c)
{
 u8 BitCnt;
 SDA_OUT();
 for(BitCnt=0;BitCnt<8;BitCnt++)  /*Ҫ͵ݳΪ8λ*/
    {
     if((c<<BitCnt)&0x80)IIC_SDA=1;   /*жϷλ*/
       else  IIC_SDA=0;                
    //delay_us(1);	
     IIC_SCL=1;               /*ʱΪߣ֪ͨʼλ*/
    delay_us(12);	               /*֤ʱӸߵƽڴ4s*/
     IIC_SCL=0; 
	 delay_us(12);
    }  
  delay_us(12);	
    IIC_SDA=1;               /*8λͷߣ׼Ӧλ*/
 delay_us(12);	 
    IIC_SCL=1;
 delay_us(12);	
		SDA_IN();
    if(READ_SDA==1)ack=0;     
       else ack=1;        /*жǷյӦź*/
    IIC_SCL=0;
   delay_us(12);	
}

/*******************************************************************
                 ֽݴͺ               
ԭ: uchar  RcvByte();
:  մ,жߴ(Ӧź)
     Ӧ  
********************************************************************/	
u8  RcvByte(u8 ak)
{
  u8 retc;
  u8 BitCnt;
  SDA_IN();
  retc=0; 
  IIC_SDA=1;             /*Ϊ뷽ʽ*/
  for(BitCnt=0;BitCnt<8;BitCnt++)
      {
      delay_us(12);	         
        IIC_SCL=0;       /*ʱΪͣ׼λ*/
      delay_us(12);	        /*ʱӵ͵ƽڴ4.7s*/      
        IIC_SCL=1;       /*ʱΪʹЧ*/
      delay_us(12);	
        retc=retc<<1;
        if(READ_SDA==1)retc=retc+1; /*λ,յλretc  IIC_SDA   */
      delay_us(12);	
      }
  if(ak==0) {;}           
	if(ak==1) {;}  	      
  IIC_SCL=0;    
  delay_us(12);	
  return retc;
}

/********************************************************************
                     ӦӺ
ԭ:  void Ack_I2c(bit a);
 
:Ӧź,(ӦӦź)
********************************************************************/
void Ack_I2c(u8 a)
{
  SDA_OUT();
  if(a==0)IIC_SDA=0;     /*ڴ˷ӦӦź */
     else IIC_SDA=1;
 delay_us(12);	     
  IIC_SCL=1;
  delay_us(12);	              /*ʱӵ͵ƽڴ4s*/
 IIC_SCL=0;                /*ʱߣǯסI2CԱ*/
  delay_us(12);	  
}

/*******************************************************************
                    ӵַֽݺ               
ԭ: bit  IRcvByte(uchar sla,ucahr *c);  
:     ߵ͵ַݣߵȫ,
          ַslaֵc.
           1ʾɹ
ע⣺    ʹǰѽߡ
********************************************************************/
u8 IRcvByte(u8 sla,u8 *c)
{
   Start_I2c();                /**/
   SendByte(sla+1);           /*ַ*/
     if(ack==0)return(0);
   *c=RcvByte(1);               /*ȡ*/
                   /*ͷǾʹλ*/
  Stop_I2c();                  /**/ 
  return(1);
}

/*******************************************************************
                    ӵַȡֽݺ               
ԭ: bit  ISendStr(uchar sla,uchar suba,ucahr *s,uchar no);  
:     ߵ͵ַӵַ,ݣߵȫ,
          ַslaӵַsubaݷsָĴ洢noֽڡ
           1ʾɹ
ע⣺    ʹǰѽߡ
********************************************************************/
u8 IRcvStr(u8 sla,u8 suba,u8 *s,u8 no)
{
 u8 i;
   Start_I2c();               /**/
   SendByte(sla);            /*ַ*/
     if(ack==0)return(0);
   SendByte(suba);            /*ӵַ*/
     if(ack==0)return(0);
   Start_I2c();
   SendByte(sla+1);
      if(ack==0)return(0);
   for(i=0;i<no-1;i++)
    {   
     *s=RcvByte(0);               
      Ack_I2c(0);                /*;ʹλ*/  
     s++;
    } 
   *s=RcvByte(1);
    Ack_I2c(1);                 /*ͷӦλ*/
    Stop_I2c();                    /**/ 
  return *s;
}









